#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>

#include <EEPROM.h>


Adafruit_PCD8544 display = Adafruit_PCD8544(3, 4, 5, 6, 7);

#define Trig 8
#define Echo 9
#define ledPin 13
unsigned int impulceTime = 0;
unsigned int distance_sm = 0;
int col = 0;
int podxod = 0;
int b1 ;
int s = 0, coin = 0;
int day = 0;
int flag = 0;
int t = 0, f = 0;
byte pr = 0;
unsigned int r = 0;
boolean bp = true;
int p = 0 ;
int z;
int per = 0 ;

//int x = sens();
int mas_easy[18][5] = {
  {2, 3, 2, 2, 3},
  {3   , 4 ,  2 ,  3  , 4},
  {4  , 5  , 4   , 4   , 5},

  {4   , 6   , 4   , 4   , 6},
  {5   , 6 ,  4 ,  4   , 7},
  {5   , 7   , 5  , 5   , 8},

  {10   , 12  , 7  , 7  , 9},
  {10   , 12   , 8  , 8   , 12},
  {11   , 13   , 9 ,  9   , 13},

  {12   , 14   , 11   , 10  , 16	},
  {14   , 16  , 12  , 12   , 18	},
  {16   , 18   , 13   , 13   , 20	},

  {17   , 19,   15 ,  15   , 20	},
  {10   , 10   , 13   , 13   , 10  },
  {13   , 13  , 15 ,  15   , 12  },

  {25   , 30   , 20   , 15   , 40},
};
//int mas_easy2[2][9] ={
//{14   14   15   15   14   14   10   10   44	},
//{13   13   17   17   16   16   14   14   50	}
//};

void schet ( ) {
  podxod = mas_easy[day][p];
  digitalWrite(Trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(Trig, LOW);
  impulceTime = pulseIn(Echo, HIGH);
  distance_sm = impulceTime / 58;
  while (distance_sm < 10) {
    Serial.println(distance_sm);
    digitalWrite(Trig, HIGH);
    delayMicroseconds(10);
    digitalWrite(Trig, LOW);
    impulceTime = pulseIn(Echo, HIGH);
    distance_sm = impulceTime / 58;
    flag = 1;
  }
  while ((flag == 1) && (distance_sm > 15) )  {
    digitalWrite(Trig, HIGH);
    delayMicroseconds(10);
    digitalWrite(Trig, LOW);
    impulceTime = pulseIn(Echo, HIGH);
    distance_sm = impulceTime / 58;
    Serial.println(distance_sm);
    // if (day == 1) day = EEPROM.read(0);
    if ((distance_sm > 17) && (distance_sm < 40) ) {
      Serial.println(distance_sm);
      digitalWrite(Trig, HIGH);
      delayMicroseconds(10);
      digitalWrite(Trig, LOW);
      impulceTime = pulseIn(Echo, HIGH);
      distance_sm = impulceTime / 58;

      col++;
      //podxod = mas_easy[day][p];
      flag = 0;
    }
  }
  if (distance_sm > 80) {
    Serial.println(distance_sm);
    //col = col;
  }

  if (col == podxod) {
    // Serial.println(col);
    col = 0;
    p++ ;
    display.clearDisplay();
    display.setTextSize(2);
    display.setCursor(30, 0);
    display.print("pereriv");
    display.display();
    delay(5000);
  }
  if (p == 6) {
    p = 1;
    day++;
    EEPROM.write(0, day);
  }



}


void disp(int h, int x, int y, int ts) {
  display.setTextColor(BLACK);
  display.setCursor(x, y);
  display.setTextSize(ts);
  int d = h / 10;
  int e = h - d * 10;
  display.clearDisplay();



  if (d == 1) display.write('1');
  if (d == 2) display.write('2');
  if (d == 3) display.write('3');
  if (d == 4) display.write('4');
  if (d == 5) display.write('5');
  if (d == 6) display.write('6');
  if (d == 7) display.write('7');
  if (d == 8) display.write('8');
  if (d == 9) display.write('9');
  if (d == 0) display.write('0');

  if (e == 1) display.write('1');
  if (e == 2) display.write('2');
  if (e == 3) display.write('3');
  if (e == 4) display.write('4');
  if (e == 5) display.write('5');
  if (e == 6) display.write('6');
  if (e == 7) display.write('7');
  if (e == 8) display.write('8');
  if (e == 9) display.write('9');
  if (e == 0) display.write('0');
  display.display();
}

int i;
void setup() {
  pinMode(Trig, OUTPUT);
  pinMode(Echo, INPUT);
  pinMode(2, INPUT_PULLUP);
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);
  display.begin();

  //  
  display.clearDisplay();
  display.display();

  //  
  display.setContrast(60);
  delay(1000);
  display.display();
}

void loop() {



  b1 = digitalRead(2);
  /*display.clearDisplay();
  display.setTextSize(1);
  display.setCursor(50,40);
  display.print(distan*/
  display.setTextSize(1);
  display.setCursor(40, 50);
  display.print(flag);
  display.setTextSize(1);
  display.setCursor(1, 0);
  display.print("sets");
  for (i = 0 ; i <= 4 ; i++) {
    display.setTextSize(1);
    display.setCursor(15 * (i+1) - 8, 10);
    display.print (mas_easy[0][i]);

  }
  display.display();
  delay(1000);
  while (b1 == 0) {
    Serial.println(distance_sm);
     display.setTextSize(1);
     display.setCursor(0, 30);
     display.print (col);
     display.display();
   
     display.setTextSize(1);
     display.setCursor(40, 50);
     display.print(flag);
     display.display();
    
    digitalWrite(Trig, HIGH);
    delayMicroseconds(10);
    digitalWrite(Trig, LOW);
    impulceTime = pulseIn(Echo, HIGH);
    distance_sm = impulceTime / 58;
    schet();
    
  }
  
}